package colorspace

type Illuminant = ColorCoordinate

// Standard Illuminants in 2 degree form
var (
	IlluminantD50 = Illuminant{0.34567, 0.35850}
	IlluminantD55 = Illuminant{0.33242, 0.34743}

	// IlluminantD60 P3-D60 (ACES Cinema)
	IlluminantD60 = Illuminant{0.32168, 0.33767}

	// IlluminantD63 P3-DCI (Theater)
	IlluminantD63 = Illuminant{0.314, 0.351}

	// IlluminantD65 Standard D65 for Rec. 709, Rec. 2020, sRGB and many more
	IlluminantD65 = Illuminant{0.31271, 0.32902}
)
