package colorspace

import "math"

// XYZSystem An absolute representation
type XYZSystem struct {
	gamma       float64
	ToLinearLUT LUT
	// ToLinear any adjustements on top of gamma
	ToLinearTransfer TransferFunction
}

func (s XYZSystem) ToLinearFrom16(c uint16) float64 {
	return s.ToLinearTransfer(s.ToLinearLUT[c])
}

func (s XYZSystem) ToLinear(c float64) float64 {
	return s.ToLinearTransfer(math.Pow(c, s.gamma))
}

func NewXYZSystem(gamma float64, toLinearTransfer TransferFunction) XYZSystem {
	return XYZSystem{
		ToLinearLUT:      NewGammaLUT(gamma, 16),
		ToLinearTransfer: toLinearTransfer,
	}
}

var DCIXYZSystem = NewXYZSystem(GammaDCIXYZ, TransferFromDCIXYZ)
