


#define _lit(s) s
#define lit(s) _lit(s)
#define _str(s) #s
#define str(s) _str(s)
#define _concat(a,b) a##b
#define concat(a,b) _concat(a,b)
#define _concat3(a,b,c) a##b##c
#define concat3(a,b,c) _concat3(a,b,c)


#if XYZ_LOOKUP_TABLE_SIZE==12
#define typed_gather_double(i32gather, packed) i32gather(xyz12_to_linear_double, packed, 8)
#define typed_gather_float(i32gather, packed) i32gather(xyz12_to_linear_float, packed, 4)
#else
#error "Not supported"
#endif

#define _shuf_lane_step1(l) 3*l, 3*l+2, 3*l+1
#define _shuf_lane_step2(l) 3*l+1, 3*l, 3*l+2
#define _shuf_idx(seti, step) seti(0xf, _shuf_lane_step##step(4), _shuf_lane_step##step(3), _shuf_lane_step##step(2), _shuf_lane_step##step(1), _shuf_lane_step##step(0))

// xxxxxyyyyyzzzzz0

#define typed_mul_vec_dot_5_fma_1(fVectorType, seti, fmadd, mul, add, permuteLanesVar, m0, m1, m2, v) \
    fmadd( \
        permuteLanesVar(_shuf_idx(seti, 2), v), \
        m2, \
        fmadd( \
           permuteLanesVar(_shuf_idx(seti, 1), v), \
           m1, \
           mul(v, m0) \
        ) \
    )

#define typed_mul_vec_dot_2_fma_1(fVectorType, seti, fmadd, mul, add, permuteLanes, m0, m1, m2, v) \
    fmadd( \
        permuteLanes(v, 0b11010010), \
        m2, \
        fmadd( \
            permuteLanes(v, 0b11001001), \
            m1, \
            mul(v, m0) \
        ) \
    )

#define typed_mul_vec_dot_2_fma_0(fVectorType, seti, fmadd, mul, add, permuteLanes, m0, m1, m2, v) \
    add( \
        add( \
            mul(v, m0), \
            mul(permuteLanes(v, 0b11001001), m1) \
        ), \
        mul(permuteLanes(v, 0b11010010), m2) \
    )

#define typed_mul_vec_dot_1_fma_1(fVectorType, seti, fmadd, mul, add, permuteLanes, m0, m1, m2, v) \
typed_mul_vec_dot_2_fma_1(fVectorType, seti, fmadd, mul, add, permuteLanes, m0, m1, m2, v)

#define typed_mul_vec_dot_1_fma_0(fVectorType, seti, fmadd, mul, add, permuteLanes, m0, m1, m2, v) \
typed_mul_vec_dot_2_fma_0(fVectorType, seti, fmadd, mul, add, permuteLanes, m0, m1, m2, v)


#define typed_mul_vec_dot_1(fma, fVectorType, seti, fmadd, mul, add, permuteLanesVar, m0, m1, m2, v) \
typed_mul_vec_dot_1_fma_##fma(fVectorType, seti, fmadd, mul, add, permuteLanesVar, m0, m1, m2, v)

#define typed_mul_vec_dot_2(fma, fVectorType, seti, fmadd, mul, add, permuteLanesVar, m0, m1, m2, v) \
typed_mul_vec_dot_2_fma_##fma(fVectorType, seti, fmadd, mul, add, permuteLanesVar, m0, m1, m2, v)

#define typed_mul_vec_dot_5(fma, fVectorType, seti, fmadd, mul, add, permuteLanesVar, m0, m1, m2, v) \
typed_mul_vec_dot_5_fma_##fma(fVectorType, seti, fmadd, mul, add, permuteLanesVar, m0, m1, m2, v)

#define typed_yuv_add_5(seti) \
seti(0, int16MaxPlusOne, int16MaxPlusOne, 0, int16MaxPlusOne, int16MaxPlusOne, 0, int16MaxPlusOne, int16MaxPlusOne, 0, int16MaxPlusOne, int16MaxPlusOne, 0, int16MaxPlusOne, int16MaxPlusOne, 0)
#define typed_yuv_add_2(seti) \
seti(0, int16MaxPlusOne, int16MaxPlusOne, 0, 0, int16MaxPlusOne, int16MaxPlusOne, 0)
#define typed_yuv_add_1(seti) \
seti(0, int16MaxPlusOne, int16MaxPlusOne, 0)


#define typed_mat_load_func_5(setf, m, in) \
m[0] = setf(0, in[8], in[4], in[0], in[8], in[4], in[0], in[8], in[4], in[0], in[8], in[4], in[0], in[8], in[4], in[0]); /*0 bgr bgr bgr bgr bgr*/ \
m[1] = setf(0, in[6], in[5], in[1], in[6], in[5], in[1], in[6], in[5], in[1], in[6], in[5], in[1], in[6], in[5], in[1]); /*0 rbg rbg rbg rbg rbg*/ \
m[2] = setf(0, in[7], in[3], in[2], in[7], in[3], in[2], in[7], in[3], in[2], in[7], in[3], in[2], in[7], in[3], in[2]); /*0 grb grb grb grb grb*/

#define typed_mat_load_func_2(setf, m, in) \
m[0] = setf(0, in[8], in[4], in[0], 0, in[8], in[4], in[0]); /* 0bgr 0bgr*/ \
m[1] = setf(0, in[6], in[5], in[1], 0, in[6], in[5], in[1]); /* 0rbg 0rbg*/ \
m[2] = setf(0, in[7], in[3], in[2], 0, in[7], in[3], in[2]); /* 0grb 0grb*/

#define typed_mat_load_func_1(setf, m, in) \
m[0] = setf(0, in[8], in[4], in[0]); /* 0bgr*/ \
m[1] = setf(0, in[6], in[5], in[1]); /* 0rbg*/ \
m[2] = setf(0, in[7], in[3], in[2]); /* 0grb*/

// todo: optimize pow via https://stackoverflow.com/questions/6475373/optimizations-for-pow-with-const-non-integer-exponent ?

#define _load_matrix_func _load_matrix_
#define _line_func convert_line_dci_xyz12_to_yuv16_
//concat(_line_func, floatType)

#define typed_converter_pump1(floatType, fVectorType, iPackedType, elementCount, set1f, setf, seti, fmaddf, mulf, addf, hasFMA, permuteLanesf, i32gather, minf, maxf, addi, ftoi, fpow, packedLoadFunc, packedStoreFunc) \
fVectorType xyz2rgb_mat_##floatType[3] __attribute__((aligned(64))); \
fVectorType rgb2yuv_mat_##floatType[3] __attribute__((aligned(64))); \
floatType xyz12_to_linear_##floatType[1 << XYZ_LOOKUP_TABLE_SIZE] __attribute__((aligned(64))); \
\
void concat(_load_matrix_func, floatType) (fVectorType* m, const double* restrict in) { \
    typed_mat_load_func_##elementCount(setf, m, in) \
}; \
\
\
inline __attribute__((always_inline)) void concat(_line_func, floatType) (const uint32_t* restrict in, uint16_t* restrict luma, uint16_t* restrict cb, uint16_t* restrict cr, int width, int height) { \
    iPackedType packed; \
    fVectorType xyz; \
    fVectorType rgb; \
    fVectorType yuv; \
    \
    const fVectorType minValue = set1f(1.); \
    const fVectorType maxValue = set1f(0.); \
    const iPackedType yuv2packed_add = typed_yuv_add_##elementCount(seti); \
    \
    const fVectorType x0 = xyz2rgb_mat_##floatType[0]; \
    const fVectorType x1 = xyz2rgb_mat_##floatType[1]; \
    const fVectorType x2 = xyz2rgb_mat_##floatType[2]; \
    \
    const fVectorType y0 = rgb2yuv_mat_##floatType[0]; \
    const fVectorType y1 = rgb2yuv_mat_##floatType[1]; \
    const fVectorType y2 = rgb2yuv_mat_##floatType[2]; \
    \
    for (int j = 0; j < width; j += elementCount) { \
        packed = packedLoadFunc(j, in); \
        \
        xyz = typed_gather_##floatType(i32gather, packed); \
        \
        rgb = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz); \
        \
        rgb = maxf(minf(rgb, minValue), maxValue); \
        \
        rgb = fpow(rgb, rgbGamma_g); \
        \
        yuv = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb); \
        \
        packed = addi(ftoi(yuv), yuv2packed_add); \
        \
        packedStoreFunc(packed, j, luma, cb, cr); \
    } \
};



#define typed_converter_pump2(floatType, fVectorType, iPackedType, elementCount, set1f, setf, seti, fmaddf, mulf, addf, hasFMA, permuteLanesf, i32gather, minf, maxf, addi, ftoi, fpow, packedLoadFunc, packedStoreFunc) \
fVectorType xyz2rgb_mat_##floatType[3] __attribute__((aligned(64))); \
fVectorType rgb2yuv_mat_##floatType[3] __attribute__((aligned(64))); \
floatType xyz12_to_linear_##floatType[1 << XYZ_LOOKUP_TABLE_SIZE] __attribute__((aligned(64))); \
\
void concat(_load_matrix_func, floatType) (fVectorType* m, const double* restrict in) { \
    typed_mat_load_func_##elementCount(setf, m, in) \
}; \
\
\
inline __attribute__((always_inline)) void concat(_line_func, floatType) (const uint32_t* restrict in, uint16_t* restrict luma, uint16_t* restrict cb, uint16_t* restrict cr, int width, int height) { \
    iPackedType packed0, packed1; \
    fVectorType xyz0, xyz1; \
    fVectorType rgb0, rgb1; \
    fVectorType yuv0, yuv1; \
    \
    const fVectorType minValue = set1f(1.); \
    const fVectorType maxValue = set1f(0.); \
    const iPackedType yuv2packed_add = typed_yuv_add_##elementCount(seti); \
    \
    const fVectorType x0 = xyz2rgb_mat_##floatType[0]; \
    const fVectorType x1 = xyz2rgb_mat_##floatType[1]; \
    const fVectorType x2 = xyz2rgb_mat_##floatType[2]; \
    \
    const fVectorType y0 = rgb2yuv_mat_##floatType[0]; \
    const fVectorType y1 = rgb2yuv_mat_##floatType[1]; \
    const fVectorType y2 = rgb2yuv_mat_##floatType[2]; \
    \
    for (int j = 0; j < width; j += elementCount*2) { \
        packed0 = packedLoadFunc(j, in); \
        packed1 = packedLoadFunc(j+elementCount, in); \
        \
        xyz0 = typed_gather_##floatType(i32gather, packed0); \
        xyz1 = typed_gather_##floatType(i32gather, packed1); \
        \
        rgb0 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz0); \
        rgb1 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz1); \
        \
        rgb0 = maxf(minf(rgb0, minValue), maxValue); \
        rgb1 = maxf(minf(rgb1, minValue), maxValue); \
        \
        rgb0 = fpow(rgb0, rgbGamma_g); \
        rgb1 = fpow(rgb1, rgbGamma_g); \
        \
        yuv0 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb0); \
        yuv1 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb1); \
        \
        packed0 = addi(ftoi(yuv0), yuv2packed_add); \
        packed1 = addi(ftoi(yuv1), yuv2packed_add); \
        \
        packedStoreFunc(packed0, j, luma, cb, cr); \
        packedStoreFunc(packed1, j+elementCount, luma, cb, cr); \
    } \
};


#define typed_converter_pump4(floatType, fVectorType, iPackedType, elementCount, set1f, setf, seti, fmaddf, mulf, addf, hasFMA, permuteLanesf, i32gather, minf, maxf, addi, ftoi, fpow, packedLoadFunc, packedStoreFunc) \
fVectorType xyz2rgb_mat_##floatType[3] __attribute__((aligned(64))); \
fVectorType rgb2yuv_mat_##floatType[3] __attribute__((aligned(64))); \
floatType xyz12_to_linear_##floatType[1 << XYZ_LOOKUP_TABLE_SIZE] __attribute__((aligned(64))); \
\
void concat(_load_matrix_func, floatType) (fVectorType* m, const double* restrict in) { \
    typed_mat_load_func_##elementCount(setf, m, in) \
}; \
\
\
inline __attribute__((always_inline)) void concat(_line_func, floatType) (const uint32_t* restrict in, uint16_t* restrict luma, uint16_t* restrict cb, uint16_t* restrict cr, int width, int height) { \
    iPackedType packed0, packed1, packed2, packed3; \
    fVectorType xyz0, xyz1, xyz2, xyz3; \
    fVectorType rgb0, rgb1, rgb2, rgb3; \
    fVectorType yuv0, yuv1, yuv2, yuv3; \
    \
    const fVectorType minValue = set1f(1.); \
    const fVectorType maxValue = set1f(0.); \
    const iPackedType yuv2packed_add = typed_yuv_add_##elementCount(seti); \
    \
    const fVectorType x0 = xyz2rgb_mat_##floatType[0]; \
    const fVectorType x1 = xyz2rgb_mat_##floatType[1]; \
    const fVectorType x2 = xyz2rgb_mat_##floatType[2]; \
    \
    const fVectorType y0 = rgb2yuv_mat_##floatType[0]; \
    const fVectorType y1 = rgb2yuv_mat_##floatType[1]; \
    const fVectorType y2 = rgb2yuv_mat_##floatType[2]; \
    \
    for (int j = 0; j < width; j += elementCount*4) { \
        packed0 = packedLoadFunc(j, in); \
        packed1 = packedLoadFunc(j+elementCount, in); \
        packed2 = packedLoadFunc(j+elementCount*2, in); \
        packed3 = packedLoadFunc(j+elementCount*3, in); \
        \
        xyz0 = typed_gather_##floatType(i32gather, packed0); \
        xyz1 = typed_gather_##floatType(i32gather, packed1); \
        xyz2 = typed_gather_##floatType(i32gather, packed2); \
        xyz3 = typed_gather_##floatType(i32gather, packed3); \
        \
        rgb0 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz0); \
        rgb1 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz1); \
        rgb2 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz2); \
        rgb3 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz3); \
        \
        rgb0 = maxf(minf(rgb0, minValue), maxValue); \
        rgb1 = maxf(minf(rgb1, minValue), maxValue); \
        rgb2 = maxf(minf(rgb2, minValue), maxValue); \
        rgb3 = maxf(minf(rgb3, minValue), maxValue); \
        \
        rgb0 = fpow(rgb0, rgbGamma_g); \
        rgb1 = fpow(rgb1, rgbGamma_g); \
        rgb2 = fpow(rgb2, rgbGamma_g); \
        rgb3 = fpow(rgb3, rgbGamma_g); \
        \
        yuv0 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb0); \
        yuv1 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb1); \
        yuv2 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb2); \
        yuv3 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb3); \
        \
        packed0 = addi(ftoi(yuv0), yuv2packed_add); \
        packed1 = addi(ftoi(yuv1), yuv2packed_add); \
        packed2 = addi(ftoi(yuv2), yuv2packed_add); \
        packed3 = addi(ftoi(yuv3), yuv2packed_add); \
        \
        packedStoreFunc(packed0, j, luma, cb, cr); \
        packedStoreFunc(packed1, j+elementCount, luma, cb, cr); \
        packedStoreFunc(packed2, j+elementCount*2, luma, cb, cr); \
        packedStoreFunc(packed3, j+elementCount*3, luma, cb, cr); \
    } \
};



#define typed_converter_pump8(floatType, fVectorType, iPackedType, elementCount, set1f, setf, seti, fmaddf, mulf, addf, hasFMA, permuteLanesf, i32gather, minf, maxf, addi, ftoi, fpow, packedLoadFunc, packedStoreFunc) \
fVectorType xyz2rgb_mat_##floatType[3] __attribute__((aligned(64))); \
fVectorType rgb2yuv_mat_##floatType[3] __attribute__((aligned(64))); \
floatType xyz12_to_linear_##floatType[1 << XYZ_LOOKUP_TABLE_SIZE] __attribute__((aligned(64))); \
\
void concat(_load_matrix_func, floatType) (fVectorType* m, const double* restrict in) { \
    typed_mat_load_func_##elementCount(setf, m, in) \
}; \
\
\
inline __attribute__((always_inline)) void concat(_line_func, floatType) (const uint32_t* restrict in, uint16_t* restrict luma, uint16_t* restrict cb, uint16_t* restrict cr, int width, int height) { \
    iPackedType packed0, packed1, packed2, packed3, packed4, packed5, packed6, packed7; \
    fVectorType xyz0, xyz1, xyz2, xyz3, xyz4, xyz5, xyz6, xyz7; \
    fVectorType rgb0, rgb1, rgb2, rgb3, rgb4, rgb5, rgb6, rgb7; \
    fVectorType yuv0, yuv1, yuv2, yuv3, yuv4, yuv5, yuv6, yuv7; \
    \
    const fVectorType minValue = set1f(1.); \
    const fVectorType maxValue = set1f(0.); \
    const iPackedType yuv2packed_add = typed_yuv_add_##elementCount(seti); \
    \
    const fVectorType x0 = xyz2rgb_mat_##floatType[0]; \
    const fVectorType x1 = xyz2rgb_mat_##floatType[1]; \
    const fVectorType x2 = xyz2rgb_mat_##floatType[2]; \
    \
    const fVectorType y0 = rgb2yuv_mat_##floatType[0]; \
    const fVectorType y1 = rgb2yuv_mat_##floatType[1]; \
    const fVectorType y2 = rgb2yuv_mat_##floatType[2]; \
    \
    for (int j = 0; j < width; j += elementCount*8) { \
        packed0 = packedLoadFunc(j, in); \
        packed1 = packedLoadFunc(j+elementCount, in); \
        packed2 = packedLoadFunc(j+elementCount*2, in); \
        packed3 = packedLoadFunc(j+elementCount*3, in); \
        packed4 = packedLoadFunc(j+elementCount*4, in); \
        packed5 = packedLoadFunc(j+elementCount*5, in); \
        packed6 = packedLoadFunc(j+elementCount*6, in); \
        packed7 = packedLoadFunc(j+elementCount*7, in); \
        \
        xyz0 = typed_gather_##floatType(i32gather, packed0); \
        xyz1 = typed_gather_##floatType(i32gather, packed1); \
        xyz2 = typed_gather_##floatType(i32gather, packed2); \
        xyz3 = typed_gather_##floatType(i32gather, packed3); \
        xyz4 = typed_gather_##floatType(i32gather, packed4); \
        xyz5 = typed_gather_##floatType(i32gather, packed5); \
        xyz6 = typed_gather_##floatType(i32gather, packed6); \
        xyz7 = typed_gather_##floatType(i32gather, packed7); \
        \
        rgb0 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz0); \
        rgb1 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz1); \
        rgb2 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz2); \
        rgb3 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz3); \
        rgb4 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz4); \
        rgb5 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz5); \
        rgb6 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz6); \
        rgb7 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, x0, x1, x2, xyz7); \
        \
        rgb0 = maxf(minf(rgb0, minValue), maxValue); \
        rgb1 = maxf(minf(rgb1, minValue), maxValue); \
        rgb2 = maxf(minf(rgb2, minValue), maxValue); \
        rgb3 = maxf(minf(rgb3, minValue), maxValue); \
        rgb4 = maxf(minf(rgb4, minValue), maxValue); \
        rgb5 = maxf(minf(rgb5, minValue), maxValue); \
        rgb6 = maxf(minf(rgb6, minValue), maxValue); \
        rgb7 = maxf(minf(rgb7, minValue), maxValue); \
        \
        rgb0 = fpow(rgb0, rgbGamma_g); \
        rgb1 = fpow(rgb1, rgbGamma_g); \
        rgb2 = fpow(rgb2, rgbGamma_g); \
        rgb3 = fpow(rgb3, rgbGamma_g); \
        rgb4 = fpow(rgb4, rgbGamma_g); \
        rgb5 = fpow(rgb5, rgbGamma_g); \
        rgb6 = fpow(rgb6, rgbGamma_g); \
        rgb7 = fpow(rgb7, rgbGamma_g); \
        \
        yuv0 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb0); \
        yuv1 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb1); \
        yuv2 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb2); \
        yuv3 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb3); \
        yuv4 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb4); \
        yuv5 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb5); \
        yuv6 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb6); \
        yuv7 = typed_mul_vec_dot_##elementCount(hasFMA, fVectorType, seti, fmaddf, mulf, addf, permuteLanesf, y0, y1, y2, rgb7); \
        \
        packed0 = addi(ftoi(yuv0), yuv2packed_add); \
        packed1 = addi(ftoi(yuv1), yuv2packed_add); \
        packed2 = addi(ftoi(yuv2), yuv2packed_add); \
        packed3 = addi(ftoi(yuv3), yuv2packed_add); \
        packed4 = addi(ftoi(yuv4), yuv2packed_add); \
        packed5 = addi(ftoi(yuv5), yuv2packed_add); \
        packed6 = addi(ftoi(yuv6), yuv2packed_add); \
        packed7 = addi(ftoi(yuv7), yuv2packed_add); \
        \
        packedStoreFunc(packed0, j, luma, cb, cr); \
        packedStoreFunc(packed1, j+elementCount, luma, cb, cr); \
        packedStoreFunc(packed2, j+elementCount*2, luma, cb, cr); \
        packedStoreFunc(packed3, j+elementCount*3, luma, cb, cr); \
        packedStoreFunc(packed4, j+elementCount*4, luma, cb, cr); \
        packedStoreFunc(packed5, j+elementCount*5, luma, cb, cr); \
        packedStoreFunc(packed6, j+elementCount*6, luma, cb, cr); \
        packedStoreFunc(packed7, j+elementCount*7, luma, cb, cr); \
    } \
};

#define typed_func(platform, floatType, elementCount, func) typed_func_##platform##_##func(floatType, elementCount)

#define typed_vector_type(platform, floatType, elementCount) typed_vector_type_##platform(floatType, elementCount)
#define typed_vector_int_type(platform, floatType, elementCount) typed_vector_int_type_##platform(floatType, elementCount)

#define typed_vector_int_size(platform, floatType, elementCount) typed_vector_int_size_##platform##_##floatType##_##elementCount

#define typed_vector_int_size(platform, floatType, elementCount) typed_vector_int_size_##platform##_##floatType##_##elementCount

#define typed_vector_int_func(platform, floatType, elementCount) typed_vector_int_funcsize_##platform##_##floatType##_##elementCount

#define typed_converter_pumps(pumps) concat(typed_converter_pump, pumps)

#define typed_converter_platform(platform, pumps, floatType, elementCount, hasFMA, packedLoadFunc, packedStoreFunc) \
typed_converter_pumps(pumps)(floatType, \
typed_vector_type(platform, floatType, elementCount), \
typed_vector_int_type(platform, floatType, elementCount), \
elementCount, \
typed_func(platform, floatType, elementCount, set1), \
typed_func(platform, floatType, elementCount, set), \
typed_func(platform, floatType, elementCount, seti), \
typed_func(platform, floatType, elementCount, fmadd), \
typed_func(platform, floatType, elementCount, mul), \
typed_func(platform, floatType, elementCount, add), \
hasFMA, \
typed_func(platform, floatType, elementCount, permute_lanes), \
typed_func(platform, floatType, elementCount, i32gather), \
typed_func(platform, floatType, elementCount, min), \
typed_func(platform, floatType, elementCount, max), \
typed_func(platform, floatType, elementCount, addi), \
typed_func(platform, floatType, elementCount, ftoi), \
typed_func(platform, floatType, elementCount, pow1), \
packedLoadFunc, \
packedStoreFunc \
)


