
#define xyz12_to_linear_name xyz12_to_linear_
#define xyz12_to_linear_type(fType) concat(xyz12_to_linear_name, fType)

fType xyz12_to_linear_type(fType)[1 << XYZ_LOOKUP_TABLE_SIZE] __attribute__((aligned(64)));

#define clamp(v, min, max) (v < min ? min : (v > max ? max : v))

#define M(m, i, j) (m[i*3+j])

#define mxv_step_name mxv_step_
#define _line_name convert_line_dci_xyz12_to_yuv16_

inline __attribute__((always_inline)) fType concat(mxv_step_name, fType) (const double* matrix, int step, fType a, fType b, fType c) {
    return M(matrix, step, 0)*a + M(matrix, step, 1)*b + M(matrix, step, 2)*c;
}

inline __attribute__((always_inline)) void concat(_line_name, fType) (const uint32_t* restrict in, uint16_t* restrict luma, uint16_t* restrict cb, uint16_t* restrict cr, int width, int height) {
    fType xyz[3] __attribute__((aligned(32)));
    fType rgb[3] __attribute__((aligned(32)));
    fType yuv[3] __attribute__((aligned(32)));

    const fType rgbGamma_l = rgbGamma_g;

    for (int j = 0; j < width; j++) {
        xyz[0] = xyz12_to_linear_type(fType)[in[j*3] << (XYZ_LOOKUP_TABLE_SIZE - 12)];
        xyz[1] = xyz12_to_linear_type(fType)[in[j*3+1] << (XYZ_LOOKUP_TABLE_SIZE - 12)];
        xyz[2] = xyz12_to_linear_type(fType)[in[j*3+2] << (XYZ_LOOKUP_TABLE_SIZE - 12)];

        rgb[0] = concat(mxv_step_name, fType)(xyz2rgb_g, 0, xyz[0], xyz[1], xyz[2]);
        rgb[1] = concat(mxv_step_name, fType)(xyz2rgb_g, 1, xyz[0], xyz[1], xyz[2]);
        rgb[2] = concat(mxv_step_name, fType)(xyz2rgb_g, 2, xyz[0], xyz[1], xyz[2]);

        rgb[0] = clamp(rgb[0], 0., 1.);
        rgb[1] = clamp(rgb[1], 0., 1.);
        rgb[2] = clamp(rgb[2], 0., 1.);

        // todo: optimize this via https://stackoverflow.com/questions/6475373/optimizations-for-pow-with-const-non-integer-exponent ?

        if (sizeof(fType) == 4){
            rgb[0] = powf(rgb[0], rgbGamma_l);
            rgb[1] = powf(rgb[1], rgbGamma_l);
            rgb[2] = powf(rgb[2], rgbGamma_l);
        } else if (sizeof(fType) == 8){
            rgb[0] = pow(rgb[0], rgbGamma_l);
            rgb[1] = pow(rgb[1], rgbGamma_l);
            rgb[2] = pow(rgb[2], rgbGamma_l);
        }

        yuv[0] = concat(mxv_step_name, fType) (rgb2yuv_g, 0, rgb[0], rgb[1], rgb[2]);
        yuv[1] = concat(mxv_step_name, fType) (rgb2yuv_g, 1, rgb[0], rgb[1], rgb[2]);
        yuv[2] = concat(mxv_step_name, fType) (rgb2yuv_g, 2, rgb[0], rgb[1], rgb[2]);

        luma[j] = clamp((int)(round(yuv[0])), 0, uint16Max);
        cb[j] = clamp((int)(round(yuv[1])) + int16MaxPlusOne, 0, uint16Max);
        cr[j] = clamp((int)(round(yuv[2])) + int16MaxPlusOne, 0, uint16Max);
    }
}